with Interfaces; use Interfaces;

package body CosNotifyChannelAdmin_StructuredProxyPushSupplier_Hash is

   P : constant array (0 .. 4) of Natural :=
     (1, 2, 4, 6, 11);

   T1 : constant array (0 .. 4) of Unsigned_8 :=
     (14, 20, 19, 50, 52);

   T2 : constant array (0 .. 4) of Unsigned_8 :=
     (11, 22, 9, 43, 4);

   G : constant array (0 .. 52) of Unsigned_8 :=
     (0, 0, 0, 3, 0, 0, 0, 15, 0, 0, 9, 17, 0, 0, 5, 24, 0, 0, 0, 0, 1, 0,
      8, 0, 7, 9, 11, 6, 0, 12, 13, 0, 0, 16, 12, 10, 0, 1, 0, 0, 0, 21, 0,
      0, 3, 11, 0, 23, 0, 0, 6, 5, 7);

   function Hash (S : String) return Natural is
      F : constant Natural := S'First - 1;
      L : constant Natural := S'Length;
      F1, F2 : Natural := 0;
      J : Natural;
   begin
      for K in P'Range loop
         exit when L < P (K);
         J  := Character'Pos (S (P (K) + F));
         F1 := (F1 + Natural (T1 (K)) * J) mod 53;
         F2 := (F2 + Natural (T2 (K)) * J) mod 53;
      end loop;
      return (Natural (G (F1)) + Natural (G (F2))) mod 26;
   end Hash;

end CosNotifyChannelAdmin_StructuredProxyPushSupplier_Hash;
